#!/usr/bin/perl

###############################################################################
# Version
# Auther: Takashi Sato.
###############################################################################
$VERSION = "Data logger. Ver.0.1, June 15, 2019";

&initDefine;

if ( $isCalled == 0 ) {

    print "Content-type: text/html\n\n";

    &main;
}

1;

###############################################################################
# Initial Definition
###############################################################################
sub initDefine {

    $PROG = $0;
    $PROG =~ s@^.*/@@;

    $TITLENAME = "QR code";

    $DATA_DIR = "data_qrdata/";
    $HTML_DIR = "../race/";

    $DATA_INTERVAL = 60; # 60 sec

    %RACE_INFO = ( 'relay' => { 'type' => 'multi', 'title' => 'リレー', 'min' => 1, 'max' => 99, 'start' => '10:30' },
		   '5km' => { 'type' => 'single', 'title' => '個人5km', 'min' => 101, 'max' => 999, 'start' => '10:30' },
		   'kid' => { 'type' => 'single', 'title' => '親子ラン', 'min' => 1001, 'max' => 9999, 'start' => '10:40' } );
}


###############################################################################
# main
###############################################################################
sub main {
#######################################
# Multibyte decode, parameter expand
#######################################
    %keys = ();
    my @params;

    if ($ENV{'REQUEST_METHOD'} eq "GET") {
	@params = split( "&", $ENV{ "QUERY_STRING" } );
	$METHOD = "GET";

    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
	@params = split(/&/, $query_string);
	$METHOD = "POST";

    } else {
 	@params = @ARGV;
	$METHOD = "PERL";

    }

 	my $p;
	for $p ( @params ) {
	    my $key, $value;
	    ( $key, $value ) = split( "=", $p );
	    $key =~ tr/+/ /;
	    $key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#	    &jcode'convert(*key, "jis");
	    $value =~ tr/+/ /;
	    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#	    $value =~ s/¥r¥n/¥n/g;
#	    &jcode'convert(*value, "jis");
	    $keys{ $key } = $value;
	}


#######################################
# Main
#######################################

    if ( $keys{ "clear" } ) {
	&ClearDataFile;
    }

    &PrintHeader;

    if ( $keys{"code"} ne "" ) {
	&AddDataFile;

    } elsif ( $keys{"query"} eq "data" ) {
	&PrintFileData;

    } elsif ( $keys{"query"} eq "file" ) {
	&PrintFileList;

    } else {
	&makeDataDict;
	if ( $keys{"result"} eq "code" ) {
	    &PrintResultCode( $keys{"race"} );

	} elsif ( $keys{"result"} eq "time" ) {
	    &PrintResultTime( $keys{"race"} );

	} elsif ( $keys{"result"} eq "team" ) {
	    &PrintResultTeam( $keys{"race"} );

	} else {
	    &PrintDataDict;
	}
    }

    &PrintFooter;

}



###############################################################################
# Header
###############################################################################
sub PrintHeader {
    print "<html>\n";
    print "<head>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";
    if ( $keys{ "refresh" } ) {
	print "<meta http-equiv=\"Refresh\" content=\"60\">";
    }
    print "<title>" . $TITLENAME . "</title>\n";
    print "</head>\n";
#    print "<body bgcolor=\"" . $BACKCOLOR . "\">\n";
}

###############################################################################
# Footer
###############################################################################
sub PrintFooter {

    print "</body>\n";
    print "</html>\n";
}

###############################################################################
# sub Module
###############################################################################


#####################
# File Command
#####################

sub PrintDataDict {
    print "<table border=1>\n";

    foreach my $key ( sort { $a <=> $b } keys( %qrdata ) ) {
	print "<tr><td>" . $key . "</td>";
	my $dict = $qrdata{$key};
	my $race = $dict->{race};
	print "<td>" . $name . "</td>";
	print "<td>" . $RACE_INFO{$race}->{type} . "</td>";
	print "<td>" . $RACE_INFO{$race}->{start} . "</td>";

	print "<td>" . $dict->{count} . " round</td>";
	print "<td> 1st: " . &time2str( $dict->{first} ) . "</td>";
	print "<td> last: " . &time2str( $dict->{last} ) . "</td>";
	my $times = $dict->{time};
	foreach $time ( @$times ) {
	    print "<td>" . &time2str( $time ), "</td>";
	}
	print "</tr>\n";
    }

    print "</table>\n";
}

sub PrintResultTeam {
    my ( $code ) = @_;

    print "<table border=1>\n";

    print "<h3>" . $code . "</h3>\n";

    my $dict = $qrdata{$code};
    my $race = $dict->{race};
    my $type = $RACE_INFO{$race}->{type};
    my $start = str2time( $RACE_INFO{$race}->{start} );

    print "<tr><td>" . &time2str( $dict->{first} ) . "</td>";
    print "<td>" . &time2str( $dict->{first} - $start ) . "</td></tr>";

    my $times = $dict->{time};
    foreach ( my $i=1; $i<scalar( @$times ); $i++ ) {
	print "<tr><td>" . &time2str( $times->[$i] ) . "</td>";
	print "<td>" . &time2str( $times->[$i] - $times->[$i-1] ) . "</td></tr>";
    }

    print "</table>\n";

}


sub PrintResultCode {
    my ( $tgtRace ) = @_;

    print "<h3>" . $RACE_INFO{$tgtRace}->{title} . "</h3>\n";

    print "<table border=1>\n";

    my $type = $RACE_INFO{$tgtRace}->{type};
    my $start = str2time( $RACE_INFO{$tgtzRace}->{start} );

    foreach my $key ( sort { $a <=> $b } keys( %qrdata ) ) {
	my $dict = $qrdata{$key};
	my $race = $dict->{race};

	if ( $race eq $tgtRace ) {
	    print "<tr><td>" . $key . "</td>";
	    if ( $type eq 'multi' ) {
		print "<td>" . $dict->{count} . " round</td>";
		print "<td>" . &time2str( $dict->{last} - $start ) . "</td>";
	    } else {
		print "<td>" . &time2str( $dict->{first} - $start ) . "</td>";
	    }
	    print "</tr>\n";
	}
    }

    print "</table>\n";
}

sub PrintResultTime {
    my ( $tgtRace ) = @_;

    print "<h3>" . $RACE_INFO{$tgtRace}->{title} . "</h3>\n";

    print "<table border=1>\n";

    my $type = $RACE_INFO{$tgtRace}->{type};
    my $start = str2time( $RACE_INFO{$tgtRace}->{start} );

    if ( $type eq 'multi' ) {

	foreach my $dict ( sort { $b->{count} <=> $a->{count} or $a->{last} <=> $b->{last} } %qrdata ) {
	    my $race = $dict->{race};

	    if ( $race eq $tgtRace ) {
		print "<tr><td>" . $dict->{code} . "</td>";
		print "<td>" . $dict->{count} . " round</td>";
		print "<td>" . &time2str( $dict->{last} - $start ) . "</td>";
		print "</tr>\n";
	    }
	}
    } else {
	foreach my $dict ( sort { $a->{first} <=> $b->{fist} } %qrdata ) {
	    my $race = $dict->{race};

	    if ( $race eq $tgtRace ) {
		print "<tr><td>" . $dict->{code} . "</td>";
		print "<td>" . &time2str( $dict->{first} - $start ) . "</td>";
		print "</tr>\n";
	    }
	}

    }

    print "</table>\n";
}

#### make dictionary for report

sub makeDataDict {
    %qrdata = ();

    ### read files and create dictionary
    foreach $line ( &readFiles() ) {
	my ( $code, $time, $name ) = split( ',', $line );
	my $timeNum = &str2time( $time );

	if ( !( exists( $qrdata{$code} ) ) ) {
	    my $dict = {};
	    $qrdata{$code} = $dict;
	}
	my $dict = $qrdata{$code};
	if ( !( exists( $dict->{time} ) ) ) {
	    my $ary = [];
	    $dict->{time} = $ary;
	}
	my @times = @{$dict->{time}};

	push @times, $timeNum;
	@times = sort @times;
	$dict->{time} = \@times;
	$dict->{code} = $code;
    }

    ### remove sequence data in DATA INTERVAL
    foreach my $key ( keys( %qrdata ) ) {
	my $dict = $qrdata{$key};
	my @times = @{$dict->{time}};
	my $i = 1;
	while ( $i <= $#times) {
	    if ( $times[ $i ] - $times[ $i-1 ] < $DATA_INTERVAL ) {
		splice( @times, $i, 1 );
		#delete( $times->[$i] );
	    } else {
		$i++;
	    }
	}
	$dict->{time} = \@times;
    }

    ### count and pickup first and last
    foreach my $key ( keys( %qrdata ) ) {
	my $dict = $qrdata{$key};
	my @times = @{$dict->{time}};
	$dict->{count} = $#times + 1;
	$dict->{first} = @times[0];
	$dict->{last} = @times[ $#times ];
    }

    ### add race information
    foreach my $code ( keys( %qrdata ) ) {
	my $dict = $qrdata{$code};
	foreach $race ( keys %RACE_INFO ) {
	    if ( ( $code <= $RACE_INFO{$race}->{max} ) && ( $code >= $RACE_INFO{$race}->{min} ) ) {
		$dict->{race} = $race;
	    }
	}
    }
}



#####################

sub PrintFileData {
    my @data = &readFiles();

    print "<table>\n";

    foreach $item ( @data ) {
	print "<tr><td>$item</td></tr>\n";
    }

    print "</table>\n";
}

sub PrintFileList {
    my @list = &fileList();

    print "<table>\n";

    foreach $file ( @list ) {
	print "<tr><td>$file</td></tr>\n";
    }

    print "</table>\n";
}

########

sub AddDataFile {
    my $line = $keys{"code"} . ',' . $keys{"time"} . ',' . $keys{"name"};
    my $filename = $keys{"time"} . '_' . $keys{"code"} . '_' . $keys{"name"} . '_' . $METHOD . '.txt';

    $filename =~ s@[\\/\":<>\*|]@_@g;   # invalud characters for Windows => '_'

    open( OUT, ">" . $DATA_DIR . $filename );
    print OUT $line . "\n";
    close( OUT );

}

sub ClearDataFile {
    my @list = &fileList();

    foreach $file ( @list ) {
	$filepath = $DATA_DIR . $file;
	unlink $filepath;
    }
}


#### file utility ####

sub fileList {
    my @list = ();

    opendir( DIR, $DATA_DIR );
    while (defined($file = readdir(DIR))) {
	@list = ( @list, $file )   if ( $file =~ /\.txt$/ );
    }
    closedir(DIR);

    return @list;
}

sub readFiles {
    my @data = ();

    my @list = &fileList();

    foreach $file ( @list ) {
	$filepath = $DATA_DIR . $file;
	open( IN, $filepath );
	    while ( <IN> ) {
		chomp $_;
		@data = ( @data, $_ );
	    }
	close( IN );
    }

    return @data
}

#### time utilities ####

sub time2str {
    my ( $time ) = @_;
    my $hour = int( $time / 3600 );
    $time = $time % 3600;
    my $min = int( $time / 60 );
    my $sec = $time % 60;
    my $str = sprintf( "%02s:%02s:%02s", $hour, $min, $sec );
    return $str;
}

sub str2time {
    my ( $str ) = @_;
    my ( $hour, $min, $sec ) = split( ":", $str );
    if ( $min eq "" ) { # hhmmdd
	if ( length( $str ) > 6 ) {
	    $str = substr( $str, -6 );
	}
	$hour = substr( $str, 0, 2 );
	$min = substr( $str, 2, 2 );
	$sec = substr( $str, 4, 2 );
    } else {
	if ( $sec eq "" ) { # hh:mm (:ss)
	    $sec = 0;
	}
    }
    my $time = $hour * 3600 + $min * 60 + $sec;
    return $time;
}


